<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 2.9 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="./">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0-RC1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0-RC1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 2.9: More detailed models for the water lock case</h1>
                    <p>
                        In the first module, you made a start on the water lock case.
                        We identified seven different types of components, and you made a start on modeling them.
                        In this module, you additionally learned how to model synchronizing automata, shared variables, constants and algebraic variables.
                        Now it is time to adapt the water lock models to use these new concepts.
                    </p>
                    <p>
                        When you modeled the seven types of components in CIF, in the previous module, you made simple models.
                        You modeled each component as a single automaton, describing its basic behavior.
                        However, in real life, these components again consist of subcomponents.
                        The subcomponents of a component can be modeled as multiple synchronizing automata, that together capture the behavior of the larger component.
                        In this module, you will therefore extend each component by modeling its subcomponents.
                    </p>

                    <h2>Traffic lights</h2>
                    <p>
                        As you know, a leaving traffic light has two states: green and red.
                        In the previous module, you modeled this as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton LeavingTrafficLight:
                                event to_green, to_red;

                                location Red:
                                    initial;
                                    marked;
                                    edge to_green goto Green;

                                location Green:
                                    edge to_red   goto Red;
                            end
                        </code>
                    </pre>
                    <p>
                        This is an oversimplification of the component's behavior.
                        This automaton only models the actuator that turns the red and green lights on and off.
                        What is not yet modeled, are the sensors that indicate whether the light has actually turned green or red.
                    </p>
                    <p>
                        For example, imagine that the actuator of the traffic light is an electronic button that activates a switch to close an electrical circuit, and that the sensor simply measures whether the electrical circuit is closed and thus whether the light is on.
                        You can turn on the green light with the button, and a very short moment later, the green light will be on.
                        Note that, for now, we ignore that actuators and sensors can also physically break down, and thus malfunction.
                    </p>
                    <p>
                        In general, a physical component has actuators that change the component's state.
                        While an actuator can physically have many forms, such as being electrical, electronic, hydraulic or pneumatic, this does not necessarily always matter for their control.
                        Often, they can be modeled similarly, when considering them as discrete event components.
                        A component should be modeled in sufficient detail, to allow a supervisory controller to control it, without modeling unnecessary details.
                        To be informed of the effect of the actuators on the component, sensors are present that indicate changes to the component's state.
                        That is, actuators change the component's state and sensors give feedback on the component's state.
                        This understanding of physical components is key in modeling them.
                    </p>
                    <p>
                        The automaton above thus only models the leaving traffic light's actuator, which changes the traffic light's state.
                        To complete this model, the sensors that indicate when the state actually changes, should be added.
                    </p>

                    <h2>Assignment 1</h2>
                    <p>
                        Complete the model of the leaving traffic light by adding two automata, one for the green light sensor and one for the red light sensor.
                        Both automata have two locations named <code>On</code> and <code>Off</code>.
                        Also introduce two variables that indicate whether the light is green or red.
                        Check the behavior using simulation, or by computing and visualizing the state space.
                    </p>
                    <p>
                        Hints: The green light sensor goes on when the traffic light actuator is turned to green, and similarly for the red light sensor.
                        The traffic light is a certain color when the actuator and sensors are in certain locations.
                    </p>
                    <div class="accordion" id="assignment1-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment1-solution" aria-expanded="false" aria-controls="assignment1-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment1-solution" class="accordion-collapse collapse" data-bs-parent="#assignment1-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>LeavingTLActuator</code> is the same as the <code>LeavingTrafficLight</code> above, but with a different name.
                                        <code>SensorGreen</code> goes on when the light is turned to green, and goes off when it is turned to red.
                                        Contrarily, <code>SensorRed</code> goes on when the light is turned to red, and goes off when it is turned to green.
                                        Algebraic variables <code>IsGreen</code> and <code>IsRed</code> update automatically to reflect whether the green and red lights, respectively, are on or not.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton LeavingTLActuator:
                                                event to_green, to_red;

                                                location Red:
                                                    initial;
                                                    marked;
                                                    edge to_green goto Green;

                                                location Green:
                                                    edge to_red   goto Red;
                                            end

                                            automaton SensorGreen:
                                                event go_on, go_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge go_on  when LeavingTLActuator.Green goto On;

                                                location On:
                                                    edge go_off when LeavingTLActuator.Red   goto Off;
                                            end

                                            automaton SensorRed:
                                                event go_on, go_off;

                                                location On:
                                                    initial;
                                                    marked;
                                                    edge go_off when LeavingTLActuator.Green goto Off;

                                                location Off:
                                                    edge go_on  when LeavingTLActuator.Red   goto On;
                                            end

                                            alg bool IsRed   = LeavingTLActuator.Red   and SensorGreen.Off and SensorRed.On;
                                            alg bool IsGreen = LeavingTLActuator.Green and SensorGreen.On  and SensorRed.Off;
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 2</h2>
                    <p>
                        Similarly as in assignment 1, now also update the model of the bridge traffic light.
                        Is it much different?
                        Check the behavior using simulation, or by computing and visualizing the state space.
                    </p>
                    <p>
                        Hint: Consider whether it is necessary to model the detailed blinking behavior, or not.
                    </p>
                    <div class="accordion" id="assignment2-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment2-solution" aria-expanded="false" aria-controls="assignment2-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment2-solution" class="accordion-collapse collapse" data-bs-parent="#assignment2-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The structure is the same as for assignment one, and only some names are different.
                                        This makes sense, as both actuators have two states: the leaving traffic light is green or red, and the bridge traffic light is on or off.
                                    </p>
                                    <p>
                                        However, if the bridge traffic light is on, then in reality, its two red lights are blinking.
                                        But, here we only model whether the light is on and thus blinking, or is off.
                                        We assume the detailed control of the blinking behavior is taken care of by a lower-level resource controller.
                                        For controlling the water lock, the detailed blinking behavior is not relevant, and we are only concerned with when to turn the blinking on or off.
                                        The bridge traffic light is therefore modeled similarly to the leaving traffic light.
                                    </p>
                                    <p>
                                        There is however another difference.
                                        For the leaving traffic light, each of the two states of the actuator is connected to a separate light.
                                        That is, when the leaving traffic light is green, the lower light is green, and when the leaving traffic light is red, the upper light is red.
                                        The two sensors are connected to the two different lights.
                                        For the bridge traffic light however, this is not the case.
                                        The on sensor checks whether the lights are blinking, and the off sensor checks that both lights are off.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton BridgeTLActuator:
                                                event to_on, to_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge to_on  goto On;

                                                location On:
                                                    edge to_off goto Off;
                                            end

                                            automaton SensorOn:
                                                event go_on, go_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge go_on  when BridgeTLActuator.On  goto On;

                                                location On:
                                                    edge go_off when BridgeTLActuator.Off goto Off;
                                            end

                                            automaton SensorOff:
                                                event go_on, go_off;

                                                location On:
                                                    initial;
                                                    marked;
                                                    edge go_off when BridgeTLActuator.On  goto Off;

                                                location Off:
                                                    edge go_on  when BridgeTLActuator.Off goto On;
                                            end

                                            alg bool IsOn  = BridgeTLActuator.On  and SensorOn.On  and SensorOff.Off;
                                            alg bool IsOff = BridgeTLActuator.Off and SensorOn.Off and SensorOff.On;
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 3</h2>
                    <p>
                        Similarly as in assignments 1 and 2, now also update the model of the entering traffic light.
                        Check the behavior using simulation, or by computing and visualizing the state space.
                    </p>
                    <p>
                        Hints: Every single light of an entering traffic light has its own sensor that indicates whether it is on or off, just like in the leaving traffic light.
                        Also add four boolean algebraic variables that indicate whether the traffic light displays a certain signal.
                    </p>
                    <div class="accordion" id="assignment3-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment3-solution" aria-expanded="false" aria-controls="assignment3-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment3-solution" class="accordion-collapse collapse" data-bs-parent="#assignment3-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton EnteringTLActuator:
                                                event to_red_red, to_red, to_red_green, to_green;

                                                location Red:
                                                    initial;
                                                    marked;
                                                    edge to_red_red   goto RedRed;
                                                    edge to_red_green goto RedGreen;
                                                    edge to_green     goto Green;

                                                location RedRed:
                                                    marked;
                                                    edge to_red       goto Red;
                                                    edge to_red_green goto RedGreen;
                                                    edge to_green     goto Green;

                                                location RedGreen:
                                                    edge to_red       goto Red;
                                                    edge to_red_red   goto RedRed;
                                                    edge to_green     goto Green;

                                                location Green:
                                                    edge to_red       goto Red;
                                                    edge to_red_red   goto RedRed;
                                                    edge to_red_green goto RedGreen;
                                            end

                                            automaton SensorTopRed:
                                                event go_on, go_off;

                                                location On:
                                                    initial;
                                                    marked;
                                                    edge go_off when     EnteringTLActuator.Green goto Off;

                                                location Off:
                                                    edge go_on  when not EnteringTLActuator.Green goto On;
                                            end

                                            automaton SensorGreen:
                                                event go_on, go_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge go_on  when EnteringTLActuator.RedGreen or EnteringTLActuator.Green  goto On;

                                                location On:
                                                    edge go_off when EnteringTLActuator.Red      or EnteringTLActuator.RedRed goto Off;
                                            end

                                            automaton SensorBottomRed:
                                                event go_on, go_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge go_on  when     EnteringTLActuator.RedRed goto On;

                                                location On:
                                                    edge go_off when not EnteringTLActuator.RedRed goto Off;
                                            end

                                            alg bool IsRed      = EnteringTLActuator.Red      and SensorTopRed.On  and SensorGreen.Off and SensorBottomRed.Off;
                                            alg bool IsRedRed   = EnteringTLActuator.RedRed   and SensorTopRed.On  and SensorGreen.Off and SensorBottomRed.On;
                                            alg bool IsRedGreen = EnteringTLActuator.RedGreen and SensorTopRed.On  and SensorGreen.On  and SensorBottomRed.Off;
                                            alg bool IsGreen    = EnteringTLActuator.Green    and SensorTopRed.Off and SensorGreen.On  and SensorBottomRed.Off;
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Open/closed components</h2>
                    <p>
                        In module 1, we concluded that gates, culverts, traffic barriers and bridges are all similar components.
                        They can all be opened and closed by an actuator.
                        We modeled it there as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton OpenClosedComponent:
                                event to_open, to_closed;

                                location Closed:
                                    marked; initial;
                                    edge to_open   goto Open;

                                location Open:
                                    edge to_closed goto Closed;
                            end
                        </code>
                    </pre>
                    <p>
                        This is again an oversimplification of the component's behavior.
                        Consider a bridge that is closed.
                        When an operator wants to open it, they press a button, and the actuator causes the bridge to start opening.
                        The bridge then goes from a state in which it is closed to an intermediate state, because the actuator is not infinitely fast such that it is immediately open after the button is pressed.
                        Only after some time, the bridge reaches its open position.
                    </p>
                    <p>
                        The actuator that is responsible for the movement of an <code>OpenCloseComponent</code> is not infinitely fast due to physical constraints.
                        Initially, when the bridge is still closed, it is at rest, doing nothing.
                        Then, when the button is pressed to open the bridge, the actuator moves to open the bridge, and when the bridge needs to be closed, the actuator moves to close the bridge.
                        The actuator can thus either be in an opening, closing or idle state.
                    </p>
                    <p>
                        Note that this is different from the traffic lights, where there is no intermediate state.
                        The actuators of those lights turn them on and off practically instantaneously, as they don't need to warm up first, or anything like that.
                    </p>
                    <p>
                        As mentioned above, components have actuators to change the components's state and sensors that give feedback on the component's state.
                        For the <code>OpenClosedComponent</code>, another type of sensor is used.
                        This sensor can detect whether the component is in the open, closed or intermediate partially open state.
                    </p>

                    <h2>Assignment 4</h2>
                    <p>
                        Update the model of the <code>OpenClosedComponent</code>.
                        When modeling the actuator, use the locations <code>Opening</code>, <code>Closing</code> and <code>Idle</code>, and the events <code>start_opening</code>, <code>stop_opening</code>, <code>start_closing</code> and <code>stop_closing</code>.
                        Take the following physical constraints into account:
                    </p>
                    <ul>
                        <li>The actuator can only start opening when it is not already open.</li>
                        <li>The actuator can only start closing when it is not already closed.</li>
                        <li>The actuator should stop opening when it is open.</li>
                        <li>The actuator should stop closing when it is closed.</li>
                    </ul>
                    <p>
                        When modeling the sensor use the locations <code>Closed</code>, <code>Intermediate</code> and <code>Open</code>, and the events <code>closed</code>, <code>not_closed</code>, <code>open</code> and <code>not_open</code>.
                        <code>closed</code> means that the component is closed, while <code>not_closed</code> means that the component is not closed anymore.
                        Note that <code>not_closed</code> is not the same as <code>open</code>.
                    </p>
                    <p>
                        Furthermore, add three boolean algebraic variables, <code>Moving</code>, <code>Open</code> and <code>Closed</code>, that indicate whether the component is moving, open or closed, respectively.
                    </p>
                    <p>
                        Check the behavior of your model using simulation, or by computing and visualizing its state space.
                    </p>
                    <div class="accordion" id="assignment4-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment4-solution" aria-expanded="false" aria-controls="assignment4-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment4-solution" class="accordion-collapse collapse" data-bs-parent="#assignment4-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The actuator is pretty straightforward.
                                    </p>
                                    <p>
                                        The sensor has a single <code>Intermediate</code> location.
                                        From the sensor location alone, we can't see which direction it is moving.
                                        We thus use guards based on the actuator state, to go to the right next location.
                                    </p>
                                    <p>
                                        For the algebraic variable, note that it is not relevant what the sensor indicates for the component to be moving, as this is entirely determined by the actuator.
                                        Similarly, for the component to be open or closed, it is not relevant whether the component is moving, as the sensor will update once the component starts moving.
                                        The sensor state is thus sufficient.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton Actuator:
                                                event start_opening, stop_opening, start_closing, stop_closing;

                                                location Idle:
                                                    initial;
                                                    marked;
                                                    edge start_opening when not Sensor.Open   goto Opening;
                                                    edge start_closing when not Sensor.Closed goto Closing;

                                                location Opening:
                                                    edge stop_opening  when     Sensor.Open   goto Idle;

                                                location Closing:
                                                    edge stop_closing  when     Sensor.Closed goto Idle;
                                            end

                                            automaton Sensor:
                                                event closed, not_closed, open, not_open;

                                                location Closed:
                                                    initial;
                                                    marked;
                                                    edge not_closed when Actuator.Opening goto Intermediate;

                                                location Intermediate:
                                                    edge closed     when Actuator.Closing goto Closed;
                                                    edge open       when Actuator.Opening goto Open;

                                                location Open:
                                                    edge not_open   when Actuator.Closing goto Intermediate;
                                            end

                                            alg bool IsMoving = not Actuator.Idle;
                                            alg bool IsOpen   = Sensor.Open;
                                            alg bool IsClosed = Sensor.Closed;
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Final remarks</h2>
                    <p>
                        In extending the water lock component models, you wrote a lot of the same code.
                        The three types of traffic lights, for example, already have seven sensors that only differ in name.
                        Multiple gates, culverts, traffic barriers and bridges need to be modeled when modeling the entire system in the next module.
                        This would be labor intensive, even when using a copy-paste-modify approach.
                        And mistakes are easily made.
                        Therefore, in the next module, you will learn how to model such similar components in a better, more scalable way.
                    </p>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="exercises.html">Go back to Module 2.8</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="../module3">Proceed to Module 3</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
